@echo off
CLS

:init
setlocal DisableDelayedExpansion
set "batchPath=%~0"
for %%k in (%0) do set batchName=%%~nk
set "vbsGetPrivileges=%temp%\OEgetPriv_%batchName%.vbs"
setlocal EnableDelayedExpansion

:checkPrivileges
NET FILE 1>NUL 2>NUL
if '%errorlevel%' == '0' ( goto gotPrivileges ) else ( goto getPrivileges )

:getPrivileges
if '%1'=='ELEV' (echo ELEV & shift /1 & goto gotPrivileges)

echo Set UAC = CreateObject^("Shell.Application"^) > "%vbsGetPrivileges%"
echo args = "ELEV " >> "%vbsGetPrivileges%"
echo For Each strArg in WScript.Arguments >> "%vbsGetPrivileges%"
echo args = args ^& strArg ^& " "  >> "%vbsGetPrivileges%"
echo Next >> "%vbsGetPrivileges%"
echo UAC.ShellExecute "!batchPath!", args, "", "runas", 1 >> "%vbsGetPrivileges%"
"%SystemRoot%\System32\WScript.exe" "%vbsGetPrivileges%" %*
exit /B

:gotPrivileges
setlocal & pushd .
cd /d %~dp0
if '%1'=='ELEV' (del "%vbsGetPrivileges%" 1>nul 2>nul  &  shift /1)

::::::::::::::::::::::::::::
::START
::::::::::::::::::::::::::::

set "AGENT_HOME=%~dp0"
if "%PROCESSOR_ARCHITECTURE%" == "AMD64" (
    set "NSSM=%AGENT_HOME%\bin\win64\nssm.exe"
    set "AGENT_BIN_HOME=%AGENT_HOME%bin\win64"
) else (
    echo ***************************************
    echo ***************************************
    echo ***************************************
    echo.
    echo Agent supports 64-bit architecture only
    echo.
    echo ***************************************
    echo ***************************************
    echo ***************************************

    pause
    exit /b 1
)


echo.
echo **************************************
echo Updating Agent
echo **************************************
echo.

for /f "delims=" %%x in ('dir /od /b "%AGENT_BIN_HOME%\agent-windows*.exe"') do set "EXE=%%x"

@REM Get hash of existing bin file

set "filename=%AGENT_BIN_HOME%\%EXE%"
call :getHash
set EXISTINGBINHASH=%HASH%

echo "Hash for exsisting file is %EXISTINGBINHASH%"

@REM Get updates

bitsadmin.exe /transfer "Monito hash file" https://get.monito.run/latest/sha256.txt %temp%\sha256.txt

if NOT %ERRORLEVEL%==0 goto :endOfUpdates

for /f "tokens=1* delims= " %%a in (%temp%\sha256.txt) do (
  if "%%b" == "%EXE%" set "REF_HASH=%%a"
  )

set "EXE=agent-windows-amd64.exe"

if "%REF_HASH%" NEQ "%EXISTINGBINHASH%" (
    
    bitsadmin.exe /transfer "Updated bin file for Monito-agent" https://get.monito.run/latest/%EXE% %temp%\%EXE%
    if NOT %ERRORLEVEL%==0 goto :endOfUpdates

    set "filename=%temp%\%EXE%"
    set HASH=""
    call :getHash

    if "%REF_HASH%" NEQ "%HASH%" (
        echo "Dowloaded file is ok"
        copy /V /Y "%temp%\%EXE%" "%AGENT_BIN_HOME%\%EXE%"
    )
) else echo "Bin file is up to date."

:endOfUpdates

echo.
echo **************************************
echo Installing Agent
echo **************************************
echo.

echo %AGENT_HOME%
for /F "tokens=1* delims==" %%A in ('type "%AGENT_HOME%\conf\config.txt"') do (
    if "%%A" == "token" set "TOKEN=%%B"
)

If NOT "%TOKEN%"=="%TOKEN:put_the_token_here=%" (
    echo **************************************
    echo **************************************
    echo **************************************
    echo.
    echo Missing 'token' in config.txt
    echo.
    echo **************************************
    echo **************************************
    echo **************************************
    echo.
    goto done
)

echo Installing and starting service...

:: Just in case the user is installing the service again
"%NSSM%" stop Monito-agent >nul 2>&1
"%NSSM%" remove Monito-agent confirm >nul 2>&1
@REM taskkill /im java.exe /f >nul 2>&1

"%NSSM%" install Monito-agent "%AGENT_HOME%\bin\agent.bat" >nul 2>&1
"%NSSM%" set Monito-agent Description "Monito agent" >nul 2>&1
"%NSSM%" set Monito-agent Start SERVICE_AUTO_START >nul 2>&1
"%NSSM%" start Monito-agent >nul 2>&1
echo Monito agent is now running

:done
echo.
pause

goto :eof

:getHash
    if not exist %filename% (
        :: "File not found"
        set HASH=""
        goto :eof
            )
    
    certutil -hashfile %filename% SHA256 > %temp%\monitohash.txt
    for /f "usebackq  delims=" %%i in (`find /n /v "" %temp%\monitohash.txt ^| find "[2]"`) do (set str=%%i)

    :: Omit symbols
    for /f "delims=] tokens=2" %%i in ("%str%") do (set HASH=%%i)
    set HASH=%HASH: =%
    
    goto :eof

